/*
 * Copyright (c) 2014 Red Hat, Inc.  All rights reserved.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v1.0 which accompanies this distribution,
 * and is available at http://www.eclipse.org/legal/epl-v10.html
 */

package org.opendaylight.aaa.idpmapping;

/**
 * Exception thrown when the type of a value is incorrect for a given context.
 *
 * @author John Dennis &lt;jdennis@redhat.com&gt;
 */

public class InvalidTypeException extends RuntimeException {

    private static final long serialVersionUID = 4437011247503994368L;

    public InvalidTypeException() {
    }

    public InvalidTypeException(String message) {
        super(message);
    }

    public InvalidTypeException(Throwable cause) {
        super(cause);
    }

    public InvalidTypeException(String message, Throwable cause) {
        super(message, cause);
    }
}
